#include <stdint.h>

typedef struct prio_client_field_32 prio_client_field_32;

typedef struct prio_client_field_64 prio_client_field_64;

typedef struct prio_field_32 prio_field_32;

typedef struct prio_private_key prio_private_key;

typedef struct prio_public_key prio_public_key;

typedef struct prio_vector prio_vector;

struct prio_client_field_32 *prio_client_field_32_new(size_t dim,
                                                      const struct prio_public_key *pub_key1,
                                                      const struct prio_public_key *pub_key2);

void prio_client_field_32_free(struct prio_client_field_32 *client);

void prio_client_field_32_encode_simple(struct prio_client_field_32 *client,
                                        const uint32_t *data,
                                        size_t data_len,
                                        struct prio_vector **output1,
                                        struct prio_vector **output2);

struct prio_client_field_64 *prio_client_field_64_new(size_t dim,
                                                      const struct prio_public_key *pub_key1,
                                                      const struct prio_public_key *pub_key2);

void prio_client_field_64_free(struct prio_client_field_64 *client);

void prio_client_field_64_encode_simple(struct prio_client_field_64 *client,
                                        const uint64_t *data,
                                        size_t data_len,
                                        struct prio_vector **output1,
                                        struct prio_vector **output2);

struct prio_public_key *prio_public_key_new_from_base64(const char *key, size_t key_length);

struct prio_public_key *prio_public_key_new_from_private_key(const struct prio_private_key *private_key);

void prio_public_key_free(struct prio_public_key *key);

struct prio_private_key *prio_private_key_new_from_base64(const char *key, size_t key_length);

void prio_private_key_free(struct prio_private_key *key);

struct prio_field_32 *prio_field_32_from_u32(uint32_t value);

void prio_vector_get(struct prio_vector *ptr, const uint8_t **data, size_t *size);

void prio_vector_free(struct prio_vector *ptr);
